//
// EventsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class EventsAPI {
    /**
     Get recognition with provided ID

     - parameter eventId: (path)  
     - parameter eventType: (query)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEvent(eventId: UUID, eventType: EventTypeEnum, withOrigin: Bool? = nil, completion: @escaping ((_ data: ResponseGetEventApiV1EventsEventIdGet?,_ error: Error?) -> Void)) {
        getEventWithRequestBuilder(eventId: eventId, eventType: eventType, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get recognition with provided ID
     - GET /api/v1/events/{event_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter eventId: (path)  
     - parameter eventType: (query)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<ResponseGetEventApiV1EventsEventIdGet> 
     */
    open class func getEventWithRequestBuilder(eventId: UUID, eventType: EventTypeEnum, withOrigin: Bool? = nil) -> RequestBuilder<ResponseGetEventApiV1EventsEventIdGet> {
        var path = "/api/v1/events/{event_id}"
        let eventIdPreEscape = "\(eventId)"
        let eventIdPostEscape = eventIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{event_id}", with: eventIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "event_type": eventType, 
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<ResponseGetEventApiV1EventsEventIdGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get event match with provided ID

     - parameter eventId: (path)  
     - parameter eventType: (query)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventMatch(eventId: UUID, eventType: EventTypeEnum, withOrigin: Bool? = nil, completion: @escaping ((_ data: ResponseGetEventMatchApiV1EventmatchesEventIdGet?,_ error: Error?) -> Void)) {
        getEventMatchWithRequestBuilder(eventId: eventId, eventType: eventType, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get event match with provided ID
     - GET /api/v1/eventmatches/{event_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter eventId: (path)  
     - parameter eventType: (query)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<ResponseGetEventMatchApiV1EventmatchesEventIdGet> 
     */
    open class func getEventMatchWithRequestBuilder(eventId: UUID, eventType: EventTypeEnum, withOrigin: Bool? = nil) -> RequestBuilder<ResponseGetEventMatchApiV1EventmatchesEventIdGet> {
        var path = "/api/v1/eventmatches/{event_id}"
        let eventIdPreEscape = "\(eventId)"
        let eventIdPostEscape = eventIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{event_id}", with: eventIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "event_type": eventType, 
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<ResponseGetEventMatchApiV1EventmatchesEventIdGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get event matches in time period

     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter streamId: (query)  (optional)
     - parameter placeId: (query)  (optional)
     - parameter limit: (query)  (optional)
     - parameter paginationCursor: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventMatches(tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, streamId: UUID? = nil, placeId: Int? = nil, limit: Int? = nil, paginationCursor: String? = nil, withOrigin: Bool? = nil, completion: @escaping ((_ data: ResponseGetEventMatchesApiV1EventmatchesGet?,_ error: Error?) -> Void)) {
        getEventMatchesWithRequestBuilder(tsFrom: tsFrom, tsTo: tsTo, eventType: eventType, streamId: streamId, placeId: placeId, limit: limit, paginationCursor: paginationCursor, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get event matches in time period
     - GET /api/v1/eventmatches

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter streamId: (query)  (optional)
     - parameter placeId: (query)  (optional)
     - parameter limit: (query)  (optional)
     - parameter paginationCursor: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<ResponseGetEventMatchesApiV1EventmatchesGet> 
     */
    open class func getEventMatchesWithRequestBuilder(tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, streamId: UUID? = nil, placeId: Int? = nil, limit: Int? = nil, paginationCursor: String? = nil, withOrigin: Bool? = nil) -> RequestBuilder<ResponseGetEventMatchesApiV1EventmatchesGet> {
        let path = "/api/v1/eventmatches"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON(), 
                        "event_type": eventType, 
                        "stream_id": streamId, 
                        "place_id": placeId?.encodeToJSON(), 
                        "limit": limit?.encodeToJSON(), 
                        "pagination_cursor": paginationCursor, 
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<ResponseGetEventMatchesApiV1EventmatchesGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get event matches with provided object ID

     - parameter objectId: (path)  
     - parameter eventType: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventMatchesByObjectId(objectId: UUID, eventType: EventTypeEnum, completion: @escaping ((_ data: ResponseGetEventMatchesByObjectIdApiV1EventmatchesObjectsObjectIdGet?,_ error: Error?) -> Void)) {
        getEventMatchesByObjectIdWithRequestBuilder(objectId: objectId, eventType: eventType).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get event matches with provided object ID
     - GET /api/v1/eventmatches/objects/{object_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter objectId: (path)  
     - parameter eventType: (query)  

     - returns: RequestBuilder<ResponseGetEventMatchesByObjectIdApiV1EventmatchesObjectsObjectIdGet> 
     */
    open class func getEventMatchesByObjectIdWithRequestBuilder(objectId: UUID, eventType: EventTypeEnum) -> RequestBuilder<ResponseGetEventMatchesByObjectIdApiV1EventmatchesObjectsObjectIdGet> {
        var path = "/api/v1/eventmatches/objects/{object_id}"
        let objectIdPreEscape = "\(objectId)"
        let objectIdPostEscape = objectIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{object_id}", with: objectIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "event_type": eventType
        ])


        let requestBuilder: RequestBuilder<ResponseGetEventMatchesByObjectIdApiV1EventmatchesObjectsObjectIdGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get recognition events in time period

     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter streamId: (query)  (optional)
     - parameter placeId: (query)  (optional)
     - parameter limit: (query)  (optional)
     - parameter paginationCursor: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEvents(tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, streamId: UUID? = nil, placeId: Int? = nil, limit: Int? = nil, paginationCursor: String? = nil, withOrigin: Bool? = nil, completion: @escaping ((_ data: ResponseGetEventsApiV1EventsGet?,_ error: Error?) -> Void)) {
        getEventsWithRequestBuilder(tsFrom: tsFrom, tsTo: tsTo, eventType: eventType, streamId: streamId, placeId: placeId, limit: limit, paginationCursor: paginationCursor, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get recognition events in time period
     - GET /api/v1/events

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter streamId: (query)  (optional)
     - parameter placeId: (query)  (optional)
     - parameter limit: (query)  (optional)
     - parameter paginationCursor: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<ResponseGetEventsApiV1EventsGet> 
     */
    open class func getEventsWithRequestBuilder(tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, streamId: UUID? = nil, placeId: Int? = nil, limit: Int? = nil, paginationCursor: String? = nil, withOrigin: Bool? = nil) -> RequestBuilder<ResponseGetEventsApiV1EventsGet> {
        let path = "/api/v1/events"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON(), 
                        "event_type": eventType, 
                        "stream_id": streamId, 
                        "place_id": placeId?.encodeToJSON(), 
                        "limit": limit?.encodeToJSON(), 
                        "pagination_cursor": paginationCursor, 
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<ResponseGetEventsApiV1EventsGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
